/*
 * RnRStatusListener.cpp
 *
 *  Created on: 24-Jul-2018
 *      Author: vivek
 */

#include "SensorListener.h"
#include "TemperatureSensorData_DCPS.hpp"



SensorDataReaderListener::SensorDataReaderListener(){

}

SensorDataReaderListener::~SensorDataReaderListener() {}

//Subscription Matched for the RnR Service Status Topic
void SensorDataReaderListener::on_subscription_matched(
         dds::sub::DataReader<TemperatureSensor::TempSensor>& the_reader,
         const dds::core::status::SubscriptionMatchedStatus& status)
{



}

void SensorDataReaderListener::on_data_available(dds::sub::DataReader<TemperatureSensor::TempSensor>& dr)
{
	//Listener on_data_available triggered
	dds::sub::LoanedSamples<TemperatureSensor::TempSensor> samples = dr.take();
	for (dds::sub::LoanedSamples<TemperatureSensor::TempSensor>::const_iterator sample = samples.begin();
			sample < samples.end();
			++sample)
	{
		if (sample->info().valid())
		{
                	std::cout << "=== [Subscriber] message received :" << std::endl;
                	std::cout << "    Sensor_ID  : " << sample->data().Sensor_ID() << std::endl;
                        std::cout << "    temp  : " << sample->data().temp() << std::endl;
                        std::cout << "    humidity  : " << sample->data().humidity() << std::endl;
		}
	}
}


SensorDataReaderListenerWrite::SensorDataReaderListenerWrite(): tempWriter(dds::core::null){

}


SensorDataReaderListenerWrite::~SensorDataReaderListenerWrite() {}

//Subscription Matched for the RnR Service Status Topic
void SensorDataReaderListenerWrite::on_subscription_matched(
         dds::sub::DataReader<TemperatureSensor::TempSensor>& the_reader,
         const dds::core::status::SubscriptionMatchedStatus& status)
{



}

void SensorDataReaderListenerWrite::on_data_available(dds::sub::DataReader<TemperatureSensor::TempSensor>& dr)
{
	//Listener on_data_available triggered
	dds::sub::LoanedSamples<TemperatureSensor::TempSensor> samples = dr.take();
	for (dds::sub::LoanedSamples<TemperatureSensor::TempSensor>::const_iterator sample = samples.begin();
			sample < samples.end();
			++sample)
	{
		if (sample->info().valid())
		{
                	std::cout << "=== [Subscriber] message received :" << std::endl;
                	std::cout << "    Sensor_ID  : " << sample->data().Sensor_ID() << std::endl;
                        std::cout << "    temp  : " << sample->data().temp() << std::endl;
                        std::cout << "    humidity  : " << sample->data().humidity() << std::endl;
			TemperatureSensor::TempSensor tempSensorSamples;
			tempSensorSamples.Sensor_ID() = sample->data().Sensor_ID() + 10;
		        tempSensorSamples.temp()  = sample->data().temp()+ 100;
		        tempSensorSamples.humidity()   = sample->data().humidity() + 10;
			
			tempWriter << tempSensorSamples;
		}
	}
}


  














