/*
 * SensorListener.h
 *
 *  Created on: 04-Apr-2022
 *      Author: vivek
 */

#ifndef INC_SENSORLISTENERLISTENER_H_
#define INC_SENSORLISTENERLISTENER_H_

#include "TemperatureSensorData_DCPS.hpp"
#include <iostream>
#include <vector>


class SensorDataReaderListener :  public virtual dds::sub::DataReaderListener<TemperatureSensor::TempSensor>, public virtual dds::sub::NoOpDataReaderListener<TemperatureSensor::TempSensor>
{
public:

	SensorDataReaderListener();
	virtual ~SensorDataReaderListener();

	virtual void on_data_available(dds::sub::DataReader<TemperatureSensor::TempSensor>& the_reader);
 
        virtual void on_subscription_matched(
         dds::sub::DataReader<TemperatureSensor::TempSensor>& the_reader,
         const dds::core::status::SubscriptionMatchedStatus& status);   

	/** Update the StatusStorage when the listener has been notified of
	 * RnRServiceStatusDataReaderListener::on_data_available and has read some data */
};

class SensorDataReaderListenerWrite :  public virtual dds::sub::DataReaderListener<TemperatureSensor::TempSensor>, public virtual dds::sub::NoOpDataReaderListener<TemperatureSensor::TempSensor>
{
public:
	dds::pub::DataWriter<TemperatureSensor::TempSensor> tempWriter;
	SensorDataReaderListenerWrite();
	virtual ~SensorDataReaderListenerWrite();

	virtual void on_data_available(dds::sub::DataReader<TemperatureSensor::TempSensor>& the_reader);
 
        virtual void on_subscription_matched(
         dds::sub::DataReader<TemperatureSensor::TempSensor>& the_reader,
         const dds::core::status::SubscriptionMatchedStatus& status);   

	/** Update the StatusStorage when the listener has been notified of
	 * RnRServiceStatusDataReaderListener::on_data_available and has read some data */
};


#endif /* INC_SENSORLISTENERLISTENER_H_ */
