#include <iostream>

#include "TemperatureSensorData_DCPS.hpp"

int publisher(int argc, char *argv[])
{
    int result = 0;
    try
    {
        setenv("OSPL_URI","file://../ospl_config/ospl_0.xml",1);
	system("echo $OSPL_URI");
	system("ospl start");
        /* Create Domain Participant */
        dds::domain::DomainParticipant dp(org::opensplice::domain::default_id());
        /* Create Topics with default Qos*/
          dds::topic::qos::TopicQos topicQos    = dp.default_topic_qos();
                
        /** A dds::topic::Topic is created for our sample type on the domain participant. */
        dds::topic::Topic<TemperatureSensor::TempSensor> topic(dp, "TemperatureSensorTopic", topicQos);

	// This is similar to dds::topic::Topic<TemperatureSensor::TempSensor> topic(dp, "TemperatureSensorTopic")

        /** A dds::pub::Publisher is created on the domain participant. */
        dds::pub::Publisher pub(dp);


        /** A dds::pub::DataWriter is created on the Publisher & Topic with the modififed Qos. */
        dds::pub::DataWriter<TemperatureSensor::TempSensor> dw(pub, topic);

        /** A sample is created and then written. */
        TemperatureSensor::TempSensor TempSensorInstance;
	std::cout<<"Enter Sensor_ID, temp & humidity to publish: "<<std::endl;
	
	std::cin>> TempSensorInstance.Sensor_ID();
	std::cin>> TempSensorInstance.temp();
	std::cin>> TempSensorInstance.humidity();
	//TrackData::Track trackInstance(id, xPos,yPos);
	while(1)
	{
		dw << TempSensorInstance;
		std::cout << "Telemetric data published by temperature sensor with :"<<" Sensor_ID: " << TempSensorInstance.Sensor_ID()<< " | temp:" << TempSensorInstance.temp() <<" | humidity:" << TempSensorInstance.humidity() << std::endl;

		/* A short sleep ensures time is allowed for the sample to be written to the network.
		If the example is running in *Single Process Mode* exiting immediately might
		otherwise shutdown the domain services before this could occur */
		sleep(10);
	}
    }
    catch (const dds::core::Exception& e)
    {
        std::cerr << "ERROR: Exception: " << e.what() << std::endl;
        result = 1;
    }
    return result;
}


int main (int argc, char *argv[])
{
  publisher(argc, argv);
}
