#include <iostream>

#include "TemperatureSensorData_DCPS.hpp"
#include "SensorListener.h"


int subscriber(int argc, char *argv[])
{
   int result = 0;
    try
    {
        /** A domain participant and topic are created identically as in
         the ::publisher */
	setenv("OSPL_URI","file://../ospl_config/ospl_0.xml",1);
	system("echo $OSPL_URI");
        dds::domain::DomainParticipant dp1(org::opensplice::domain::default_id());

        dds::topic::Topic<TemperatureSensor::TempSensor> topic1(dp1, "TemperatureSensorTopic");

        /** A dds::sub::Subscriber is created on the domain participant. */
        dds::sub::Subscriber sub1(dp1);


	
        dds::sub::qos::DataReaderQos DRqos = topic1.qos();
	dds::core::status::StatusMask mask;
	mask << dds::core::status::StatusMask::data_available();
        /** A dds::sub::DataReader is created on the Subscriber & Topic. */
        SensorDataReaderListenerWrite sensorListenerWrite;
        dds::sub::DataReader<TemperatureSensor::TempSensor> dr1(sub1, topic1, DRqos,&sensorListenerWrite, mask);


        setenv("OSPL_URI","file://../ospl_config/ospl_1.xml",1);
        system("echo $OSPL_URI");
        system("ospl start");
        dds::domain::DomainParticipant dp2(1);

        /* Create Topics with default Qos*/
          dds::topic::qos::TopicQos topicQos2    = dp2.default_topic_qos();
                
        /** A dds::topic::Topic is created for our sample type on the domain participant. */
        dds::topic::Topic<TemperatureSensor::TempSensor> topic(dp2, "TemperatureSensorTopic", topicQos2);

	// This is similar to dds::topic::Topic<TemperatureSensor::TempSensor> topic(dp, "TemperatureSensorTopic")

        /** A dds::pub::Publisher is created on the domain participant. */
        dds::pub::Publisher pub(dp2);


        /** A dds::pub::DataWriter is created on the Publisher & Topic with the modififed Qos. */
        dds::pub::DataWriter<TemperatureSensor::TempSensor> dw(pub, topic);
	sensorListenerWrite.tempWriter = dw;


        /**  */
        while(1)
        {
            sleep(1);
        }
    }
    catch (const dds::core::Exception& e)
    {
        std::cerr << "ERROR: Exception: " << e.what() << std::endl;
        result = 1;
    }
    return result;
}

int main (int argc, char *argv[])
{
  return subscriber(argc, argv);
}
