#include <iostream>

#include "TemperatureSensorData_DCPS.hpp"
#include "SensorListener.h"


int subscriber(int argc, char *argv[])
{
   int result = 0;
    try
    {

        setenv("OSPL_URI","file://../ospl_config/ospl_1.xml",1);
        system("echo $OSPL_URI");
        system("ospl start");
        /** A domain participant and topic are created identically as in
         the ::publisher */
        dds::domain::DomainParticipant dp1(org::opensplice::domain::default_id());

        dds::topic::Topic<TemperatureSensor::TempSensor> topic1(dp1, "TemperatureSensorTopic");

        /** A dds::sub::Subscriber is created on the domain participant. */
        dds::sub::Subscriber sub1(dp1);


	SensorDataReaderListener sensorListener;
        dds::sub::qos::DataReaderQos DRqos = topic1.qos();
	dds::core::status::StatusMask mask;
	mask << dds::core::status::StatusMask::data_available();

        /** A dds::sub::DataReader is created on the Subscriber & Topic. */
        dds::sub::DataReader<TemperatureSensor::TempSensor> dr1(sub1, topic1, DRqos,&sensorListener, mask);


        while(1)
        {
            sleep(1);
        }
    }
    catch (const dds::core::Exception& e)
    {
        std::cerr << "ERROR: Exception: " << e.what() << std::endl;
        result = 1;
    }
    return result;
}

int main (int argc, char *argv[])
{
  return subscriber(argc, argv);
}
